const appRootDir = require('app-root-dir');
const gulp = require('gulp');
const del = require('del');

const webpack = require('webpack-stream');

const basePath = appRootDir.get();
const packageJson = require(basePath + '/package.json');
const packageName = packageJson.name;

gulp.task('extension:clean', function () {
  return del(basePath + '/dist/**');
});

gulp.task('extension:build', ['extension:clean'], function () {
  return gulp.src(basePath + '/src/extension.js')
    .pipe(webpack({
      module: {
        rules: [
          {
            test: /\.js$/,
            exclude: /(node_modules(^\/xethya.+)|bower_components)/,
            use: {
              loader: 'babel-loader',
              options: {
                presets: ['@babel/preset-env'],
                plugins: [
                  require('@babel/plugin-proposal-decorators'),
                  require('@babel/plugin-external-helpers'),
                  require('@babel/plugin-transform-runtime')
                ]
              }
            }
          }
        ]
      },
      output: {
        filename: packageName + '.js',
      }
    }))
    .pipe(gulp.dest(basePath + '/dist'));
});
